<template>
  <Button
    ref="element"
    :style="{
      borderColor: order.material.color,
    }"
    class="MachineOrder"
    @click="$emit('validity', !order.valid)"
  >
    <span class="MachineOrder__title">{{ order.title }}</span>
    <span class="MachineOrder__id">{{ order.id }}</span>
    <template v-if="order.schedule">
      <time
        :datetime="order.schedule.start.toISOString()"
        class="MachineOrder__start"
        >{{ formatHour(order.schedule.start) }}
      </time>
      <time
        :datetime="order.schedule.end.toISOString()"
        class="MachineOrder__end"
        >{{ formatHour(order.schedule.end) }}
      </time>
    </template>
    <Icon
      class="MachineOrder__valid"
      :icon="order.valid ? Icons.order.valid : Icons.order.unknown"
    />
  </Button>
</template>

<script lang="ts">
import { defineComponent, PropType, ref } from 'vue'
import moment from 'moment'
import { Order } from '@/types'
import { Icon, Button } from '@/components'
import { Icons } from '@/Icons'

export default defineComponent({
  name: 'MachineOrder',
  emits: ['validity'],

  components: { Icon, Button },

  props: {
    order: {
      type: Object as PropType<Order>,
      required: true,
    },
  },

  setup() {
    const element = ref<HTMLDivElement>()
    const moving = ref(false)

    return {
      Icons,
      moving,
      element,
    }
  },

  methods: {
    formatHour(date: Date): string {
      return moment(date).format('HH:mm')
    },
  },
})
</script>

<style lang="scss" scoped>
@use '../../style/variables' as v;

.MachineOrder {
  display: grid;
  grid-template-areas:
    'Title Title start valid'
    'ID ID stop valid';
  grid-template-rows: 1fr 1fr;
  grid-template-columns: 1fr 1fr 100px 100px;
  gap: 0 0;
  width: 100%;
  height: 100px;
  max-height: v.$machine-lineHeight - v.$spacing;
  padding: 10px 0 10px 20px;
  border-width: 0 0 0 v.$spacing;
  border-style: solid;
  border-left: v.$spacing solid;
  border-radius: 0 2px 2px 0;
  background-color: var(--background-color);
  color: #444;
  box-shadow: 0 1px 2px rgba(0, 0, 0, 0.15);

  &__title {
    grid-area: Title;
    font-weight: 700;
    text-align: left;
  }

  &__id {
    grid-area: ID;
    align-self: flex-end;
    font-style: italic;
    text-align: left;
  }

  &__start {
    grid-area: start;
    align-self: flex-start;
    text-align: right;
  }

  &__end {
    grid-area: stop;
    align-self: flex-end;
    text-align: right;
  }

  &__valid {
    grid-area: valid;
    align-self: center;
    justify-self: center;
    font-size: 1.5em;
  }
}
</style>
